/* fsotransport-2.0.vapi generated by valac, do not modify. */

[CCode (cprefix = "FsoFramework", lower_case_cprefix = "fso_framework_")]
namespace FsoFramework {
	[CCode (cheader_filename = "fsotransport.h")]
	public class BaseCommandQueue : FsoFramework.CommandQueue, GLib.Object {
		protected char* buffer;
		protected CommandBundle current;
		protected FsoFramework.Parser parser;
		protected Gee.LinkedList<CommandBundle> q;
		protected uint timeout;
		protected FsoFramework.Transport transport;
		protected FsoFramework.CommandQueue.UnsolicitedHandler urchandler;
		public BaseCommandQueue (FsoFramework.Transport transport, FsoFramework.Parser parser);
		protected bool _expectedPrefix (string line);
		protected bool _haveCommand ();
		protected void _onHupFromTransport (FsoFramework.Transport t);
		protected void _onReadFromTransport (FsoFramework.Transport t);
		protected bool _onTimeout ();
		protected void _solicitedCompleted (string[] response);
		protected void _unsolicitedCompleted (string[] response);
		protected void _writeRequestToTransport (string request);
		protected bool checkRestartingQ ();
		public void close ();
		protected void onHupFromTransport ();
		protected void onReadFromTransport (string response);
		protected void onResponseTimeout (CommandBundle bundle);
		protected void onSolicitedResponse (CommandBundle bundle, string[] response);
		public bool open ();
		protected void writeNextCommand ();
	}
	[CCode (cheader_filename = "fsotransport.h")]
	public class BaseParser : FsoFramework.Parser, GLib.Object {
		protected FsoFramework.Parser.ExpectedPrefixFunc expectedPrefix;
		protected FsoFramework.Parser.HaveCommandFunc haveCommand;
		protected FsoFramework.Parser.SolicitedCompletedFunc solicitedCompleted;
		protected FsoFramework.Parser.UnsolicitedCompletedFunc unsolicitedCompleted;
		public BaseParser ();
		public virtual int feed (void* data, int len);
	}
	[CCode (cheader_filename = "fsotransport.h")]
	public class BaseTransport : FsoFramework.Transport {
		protected GLib.ByteArray buffer;
		protected int fd;
		protected bool hard;
		protected FsoFramework.TransportHupFunc hupfunc;
		protected string name;
		protected bool raw;
		protected FsoFramework.TransportReadFunc readfunc;
		protected uint speed;
		public BaseTransport (string name, uint speed = 0, bool raw = true, bool hard = true);
		public override void close ();
		public override void freeze ();
		public override void getDelegates (out FsoFramework.TransportReadFunc? readfun, out FsoFramework.TransportHupFunc? hupfun);
		public override string getName ();
		public override bool isOpen ();
		public override bool open ();
		public override int read (void* data, int len);
		public virtual string repr ();
		protected void restartWriter ();
		public override void setDelegates (FsoFramework.TransportReadFunc? readfunc, FsoFramework.TransportHupFunc? hupfunc);
		public override void setPriorities (int rp, int wp);
		public override void thaw ();
		public override int write (void* data, int len);
		public override int writeAndRead (void* wdata, int wlength, void* rdata, int rlength, int maxWait = 1000);
	}
	[CCode (cheader_filename = "fsotransport.h")]
	public class LineByLineParser : FsoFramework.BaseParser {
		public LineByLineParser (string termination = "\r\n", bool swallow = true);
		public override int feed (char* data, int len);
	}
	[CCode (cheader_filename = "fsotransport.h")]
	public class NullParser : FsoFramework.BaseParser {
		public NullParser ();
		public override int feed (void* data, int len);
	}
	[CCode (cheader_filename = "fsotransport.h")]
	public class PtyTransport : FsoFramework.BaseTransport {
		public PtyTransport ();
		public override string getName ();
		public override bool open ();
		public override string repr ();
	}
	[CCode (cheader_filename = "fsotransport.h")]
	public class SerialTransport : FsoFramework.BaseTransport {
		public SerialTransport (string portname, uint portspeed, bool raw = true, bool hard = true);
		public override bool open ();
		public override string repr ();
	}
	[CCode (cheader_filename = "fsotransport.h")]
	public class SocketTransport : FsoFramework.BaseTransport {
		public SocketTransport (string type, string host, uint port);
		public override string getName ();
		public override bool open ();
		public override string repr ();
	}
	[CCode (cheader_filename = "fsotransport.h")]
	public abstract class Transport : GLib.Object {
		public FsoFramework.Logger logger;
		public Transport ();
		public abstract void close ();
		public static FsoFramework.Transport? create (string type, string name = "", uint speed = 0, bool raw = true, bool hard = true);
		public abstract void freeze ();
		public abstract void getDelegates (out FsoFramework.TransportReadFunc? readfun, out FsoFramework.TransportHupFunc? hupfun);
		public abstract string getName ();
		public abstract bool isOpen ();
		public abstract bool open ();
		public abstract int read (void* data, int length);
		public abstract void setDelegates (FsoFramework.TransportReadFunc? readfunc, FsoFramework.TransportHupFunc? hupfunc);
		public abstract void setPriorities (int rp, int wp);
		public abstract void thaw ();
		public abstract int write (void* data, int length);
		public abstract int writeAndRead (void* wdata, int wlength, void* rdata, int rlength, int maxWait = 1000);
	}
	[CCode (cheader_filename = "fsotransport.h")]
	public interface CommandQueue : GLib.Object {
		[CCode (cheader_filename = "fsotransport.h")]
		public delegate string RequestHandler (FsoFramework.CommandQueueCommand command);
		[CCode (cheader_filename = "fsotransport.h")]
		public delegate void ResponseHandler (FsoFramework.CommandQueueCommand command, string[] response);
		[CCode (cheader_filename = "fsotransport.h")]
		public delegate void UnsolicitedHandler (string prefix, string response, string? pdu = null);
		public const uint DEFAULT_RETRY;
		public abstract async string[] enqueueAsyncYielding (FsoFramework.CommandQueueCommand command, string request, uint retry = DEFAULT_RETRY);
		public abstract void freeze (bool drain = false);
		public abstract void registerUnsolicitedHandler (FsoFramework.CommandQueue.UnsolicitedHandler urchandler);
		public abstract void thaw ();
	}
	[CCode (cheader_filename = "fsotransport.h")]
	public interface CommandQueueCommand : GLib.Object {
		public abstract string get_postfix ();
		public abstract string get_prefix ();
		public abstract uint get_retry ();
		public abstract uint get_timeout ();
		public abstract bool is_valid_prefix (string line);
	}
	[CCode (cheader_filename = "fsotransport.h")]
	public interface Parser : GLib.Object {
		[CCode (cheader_filename = "fsotransport.h")]
		public delegate bool ExpectedPrefixFunc (string line);
		[CCode (cheader_filename = "fsotransport.h")]
		public delegate bool HaveCommandFunc ();
		[CCode (cheader_filename = "fsotransport.h")]
		public delegate void SolicitedCompletedFunc (string[] response);
		[CCode (cheader_filename = "fsotransport.h")]
		public delegate void UnsolicitedCompletedFunc (string[] response);
		public abstract int feed (void* data, int len);
		public abstract void setDelegates (FsoFramework.Parser.HaveCommandFunc haveCommand, FsoFramework.Parser.ExpectedPrefixFunc expectedPrefix, FsoFramework.Parser.SolicitedCompletedFunc solicitedCompleted, FsoFramework.Parser.UnsolicitedCompletedFunc unsolicitedCompleted);
	}
	[CCode (cprefix = "FSO_FRAMEWORK_TRANSPORT_STATE_", cheader_filename = "fsotransport.h")]
	public enum TransportState {
		CLOSED,
		OPEN,
		ALIVE,
		FROZEN,
		DEAD
	}
	[CCode (cprefix = "FSO_FRAMEWORK_TRANSPORT_ERROR_", cheader_filename = "fsotransport.h")]
	public errordomain TransportError {
		UNABLE_TO_OPEN,
		UNABLE_TO_WRITE,
	}
	[CCode (cheader_filename = "fsotransport.h")]
	public delegate void TransportHupFunc (FsoFramework.Transport transport);
	[CCode (cheader_filename = "fsotransport.h")]
	public delegate void TransportReadFunc (FsoFramework.Transport transport);
}
[CCode (ref_function = "command_bundle_ref", unref_function = "command_bundle_unref", cheader_filename = "fsotransport.h")]
public class CommandBundle {
	public GLib.SourceFunc callback;
	public FsoFramework.CommandQueueCommand command;
	public FsoFramework.CommandQueue.RequestHandler getRequest;
	public FsoFramework.CommandQueue.ResponseHandler handler;
	public string request;
	public string[] response;
	public uint retry;
	public CommandBundle ();
}
